con

  _clkmode = xtal1 + pll16x
  _clkfreq = 80_000_000

  MS_001   = 80_000_000 / 1_000

  MSTR = 0                                          ' Master -> Adaptor
  SLAV = 1                                          ' Adaptor -> Master

obj

  term      : "fullduplexserialdp_1"                       ' for terminal output
  comm      : "fullduplexserialdp_1"                       ' Comms between adaptor and master  

var
            
  byte  s, v, chen[6], chksum, pos      

pub main  | d, h, x, y

  term.start(31, 30, %0000, 115_200)                    ' start terminal (use PST)
  pause(1000)
  term.str(@message1)
  comm.start(MSTR, SLAV, 1, 9_600)

  chksum := 0

  repeat 
    v := comm.rxtime(2000)                                 
    if v <> -1                                          
      case v                                            
        $0C:
          pos := 0
          chksum := v
          repeat pos from 0 to 3
            v := comm.rxtime(1)
            chen[pos] := v
            chksum += v
            pos++
          v := comm.rxtime(1)               ' Why are 3 of these needed to get the next byte?
          v := comm.rxtime(1)
          v := comm.rxtime(1)    
          term.str(string("V: "))
          term.hex(v, 2)
          term.tx(32)
          term.str(string("Chksum: "))
          term.hex(chksum, 2)
          term.tx(13)
          if chksum == v
            comm.tx($00)
          term.str(string("Chen buffer: ")) 
          repeat pos from 1 to 4
            term.hex(chen[pos], 2)
            term.tx(32)
          term.tx(13)

pub pause(ms) | t

  t := cnt
  repeat ms
    waitcnt(t += MS_001)
    
dat

  message1    byte      "slave_buffer_test", 13, 13, 0             